$('body').append(`

    <div id="login" class="dlgbox dlgboxYesNo">
        <div class="dlgboxHeader">
            <h3 id="loginTitle" class="dlgboxTitle dlgboxYesNoTitle info-dlgbox">Choose your environment</h3>
        </div>
        <div class="dlgbox2">
            <div class="login dialog-buttons">
            <button id="loginCurrentEnv" class="button primary-action" onclick="redirectToLogin()"></button>
            <button id="changeEnv" class="button secondary-action" onclick="suggestOtherEnvironment()"></button>
            </div>
        </div>
    </div>

    <div id="logoutInfo" class="dlgbox dlgboxYesNo">
        <div class="dlgboxHeader">
            <h3 id="logoutInfoTitle" class="dlgboxTitle dlgboxYesNoTitle info-dlgbox"></h3>
        </div>
        <div class="dlgbox2">
            A new tab will be opened in your browser to execute the <strong>Sage Active</strong> User logout.
            <br><br>
            From this new <strong>Sage Active tab</strong>, when the user has been logged out, please close the Tab to finalize the logout process.<br><br>
            </span>    
            <div class="login dialog-buttons">
            <button id="logoutInfo" class="button primary-action" onclick="logoutExecute()">Click to Log Out</button>
            </div>
        </div>
    </div>

    <div id="logoutInProgress" class="dlgbox dlgboxYesNo">
        <div class="dlgboxHeader">
            <h3 id="logoutInfoTitle" class="dlgboxTitle dlgboxYesNoTitle info-dlgbox">Logout In Progress</h3>
        </div>
        <div class="dlgbox2">
             To proceed, close the <strong>Sage Active tab</strong> that opened after the user has been logged out.<br><br>(When Sage Active asks you to log back in with the current user).
            </div>
        </div>
    </div>

    <div class="popovers" style="display:none"></div>
    <div id="modal-background"></div>
    <div class="toolTip" style="display: none; top: 6px; left: 190px;">
        <div class="stoolTip">
        <span class="toolTip right"></span>
        <div class="toolTipContent"></div>
        </div>
    </div>
    <div class="headerpage">
        <label id="businessMessageHistoryNb" class="businessMessageHistoryNb" style="display:none"></label>
        <div class="waitContent" style="display:none">
            <div class="waitAnim"></div>
            <div class="waitAnim"></div>
            <div class="waitAnim"></div>
        </div>
        <label id="businessWarning" class="businessWarning" style="display:none"></label>
        <label id="businessError" class="businessError" style="display:none"></label>
        <label id="businessInfo" class="businessInfo" style="display:none"></label>
        <div id="timer">00:00</div>
    </div>

    <div id="dlgboxYesNo" class="dlgbox dlgboxYesNo">
        <div class="dlgboxHeader">
            <h3 id="dlgboxYesNoTitle" class="dlgboxTitle dlgboxYesNoTitle"></h3>
        </div>
        <div class="dlgbox2">
            <span id="dlgboxYesNoQuestion"></span>
            <div class="dialog-buttons">
                <button id="No" class="button secondary-action" onclick="dlgBoxYesNoCancel();">No</button>&emsp;
                <button id="Yes" class="button primary-action">Yes</button>
            </div>
        </div>
    </div>
</div>

`);

function waitInfo(show=true) { 
    $('.waitContent').css('display', show ? 'block' : 'none'); 
}

function isWaitInfoActive() {
    return $('.waitContent').css('display') === 'block';
}

function enableInterface() {
        if (isModalVisible) return;
        $("#modal-background").hide();
}

function disableInterface(transparent) {
    if (transparent) 
        $("#modal-background").addClass("modalBackgroundTransparent");
     else 
        $("#modal-background").removeClass("modalBackgroundTransparent");
    $("#modal-background").show();
}

var isModalVisible = false;
function displayModale(id, idFocus, noDisableInterface) {
    waitInfo(false);
    var modale = document.getElementById(id);
    if (modale) {
        modale.style.animationName = "fadeinScrollUp";
        modale.style.animationDuration = "0.5s";
        isModalVisible = true;
        setTimeout(function () {
            modale.style.display = "block";
            if (idFocus)
                document.getElementById(idFocus).focus();
            else
                setFocus("form" + id.substr(0, 1).toUpperCase() + id.substr(1));
            if (!noDisableInterface) disableInterface();
        }, 10);
    }
}

function hideModale(id) {
    var modale = document.getElementById(id);
    isModalVisible = false;
    if (modale) {
        modale.style.animationName = "fadeOutScrollDown";
        modale.style.animationDuration = "0.5s";
        enableInterface();
        setTimeout(function () {
            modale.style.display = "none"; 
        }, 300);

    }
}

var dlgBoxYesNo = function (type, title, question, action) {
    if (!type) type = "info"; else type = type.toLowerCase();
    dlgboxYesNoTitle = document.getElementById("dlgboxYesNoTitle");
    dlgboxYesNoTitle.className = dlgboxYesNoTitle.className.replace(/\s(info-dlgbox|warning-dlgbox)/, '');
    dlgboxYesNoTitle.classList.add(type + "-dlgbox");
    document.getElementById("Yes").onclick = function() { action(true); };
    document.getElementById("No").onclick = function() { action(false); };

    dlgboxYesNoTitle.innerHTML =  title;
    document.getElementById("dlgboxYesNoQuestion").innerHTML =  question;
    displayModale("dlgboxYesNo","No");
}

var dlgBoxYesNoCancel = function () {
    hideModale("dlgboxYesNo");
}


// Tooltip display management
$(function() {
    var toolTip = $('div.toolTip');
    var toolTipTimeout;

    function showToolTip(event) {
        var $this = $(event.target).closest('[data-hastooltip]');
        if (!$this.length) return;

        clearTimeout(toolTipTimeout);
        toolTip.removeClass('showToolTip');

        toolTipTimeout = setTimeout(function() {
            var tooltipContent = $this.find('.toolTipText').eq($this.data('rowtooltip') || 0).html();
            toolTip.find('.toolTipContent').html(tooltipContent);

            var tooltipPosition = calculateTooltipPosition($this, event);
            toolTip.css({
                top: tooltipPosition.top,
                left: tooltipPosition.left,
                display: 'none'
            }).addClass('showToolTip');
        }, event.type === 'mouseover' ? 1000 : 0);
    }

    function calculateTooltipPosition(element, event) {
        var elementOffset = element.offset();
        var toolTipHeight = toolTip.outerHeight();
        var toolTipWidth = toolTip.outerWidth();
        var elementHeight = element.outerHeight();
        var elementWidth = element.outerWidth();
    
        // Base position: to the right of the element
        var top = elementOffset.top + elementHeight / 2 - toolTipHeight / 2;
        var left = elementOffset.left + elementWidth + 5;
      
        // Adjust if the tooltip extends beyond the browser window
        var overRight = left + toolTipWidth - $(window).width();
        if (overRight > 0) {
            left = elementOffset.left - toolTipWidth - 5; // Move left
            toolTip.find('span.toolTip').removeClass('right').addClass('left');
        } else 
            toolTip.find('span.toolTip').removeClass('left').addClass('right');
       
    
        // Adjust if the top or bottom of the tooltip extends beyond the window
        var overTop = top < $(window).scrollTop();
        var overBottom = top + toolTipHeight > $(window).scrollTop() + $(window).height();
    
        if (overTop) 
            top = elementOffset.top + 20;
        else if (overBottom) 
            top = elementOffset.top - toolTipHeight - 20;
    
        return { top: top, left: left };
    }
    
    $(document).on('click mouseover', '[data-hastooltip]', showToolTip);

    $(document).on('click mouseover', function(event) {
        var $target = $(event.target);
    
        // Checks whether the element hovered over or clicked should display a tooltip
        if (!$target.closest('[data-hastooltip]').length) {
            // Hides the tooltip if it is currently displayed
            if (toolTip.is('.showToolTip')) {
                clearTimeout(toolTipTimeout);
                toolTip.removeClass('showToolTip');
            }
        }
    });
    
});

function padRight(str, length) {
    return str + '.'.repeat(length - str.length);
}

function formatDateMonthDay(dateString) {
    const monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    const date = new Date(dateString);
    const month = monthNames[date.getMonth()];
    const day = date.getDate().toString().padStart(2, '0');
    return month + day;
}



let startTime = Date.now();
let timerInterval;
function incrementTime() {
    let elapsedTime = Date.now() - startTime; 
    let totalSeconds = Math.floor(elapsedTime / 1000); 
    let hours = Math.floor(totalSeconds / 3600); 
    let minutes = Math.floor((totalSeconds % 3600) / 60); 
    let seconds = totalSeconds % 60; 

    let formattedTime;
    if (hours > 0) 
        formattedTime = `${hours}:${minutes < 10 ? "0" : ""}${minutes}:${seconds < 10 ? "0" : ""}${seconds}`;
    else 
    formattedTime = `${minutes < 10 ? "0" : ""}${minutes}:${seconds < 10 ? "0" : ""}${seconds}`;

    $('#timer').text(formattedTime);
}
$('#timer').click(function() {
    ($(this).css('opacity') == 0) ? startTimer() : hideTimer();
});


function stopTimer() {
    if (timerInterval) {
        clearInterval(timerInterval);
        timerInterval = null;
    }
}
function hideTimer() {
    $('#timer').css('opacity',0);
}
function startTimer() {
    stopTimer();
    startTime = Date.now();
    $('#timer').text("00:00");
    timerInterval=setInterval(incrementTime, 1000);
    $('#timer').css('opacity',1);
}

//popovers
// obj : ancrage du popover sur l'obj
// listItems : {item1 : {item:<libelle>, function:<function>, [current:true]},item2 : {item:<libelle>,function:<function>}, ... }

var oldObjPopovers;
function popovers(obj, listItems) {
    popoversContainer = document.querySelector(".popovers");

    if (popoversContainer.style.display != "none" && oldObjPopovers && oldObjPopovers == obj) {
        popoversContainer.style.display = "none";
        return;
    }
    oldObjPopovers = obj;
    windowInnerWidth = window.innerWidth;
    windowInnerHeight = window.innerHeight;

    while (popoversContainer.firstChild) {
        popoversContainer.removeChild(popoversContainer.firstChild);
    }
    for (const currentItem in listItems) {
        item = document.createElement('div');
        item.className = "popoversItem";       
        item.type = "button";
        if (listItems[currentItem].code) item.setAttribute("data-code", listItems[currentItem].code);
        if (listItems[currentItem].current) item.classList.add("popoversItemCurrent");
        addExtraClass(item, listItems[currentItem].extraClass);
        var libItem = listItems[currentItem].item;
        item.innerHTML = libItem;
        item.onclick = listItems[currentItem].function;
        popoversContainer.insertAdjacentElement('beforeend', item);
        
    }

    popoversContainer.style.display = "block";
    popoversContainer.style.top = (obj.documentOffsetTop + obj.offsetHeight) + "px";
    popoversContainer.style.left = (obj.documentOffsetLeft + 20) + "px";
    
    setTimeout(function () {
        popoversContainer.style.display = "block";
        
        var parentRect = document.querySelector("body").getBoundingClientRect();
        var popoverRect = popoversContainer.getBoundingClientRect();
      
        // Vérification en largeur
        if (popoverRect.right > parentRect.right) {
            let overflowAmountWidth = popoverRect.right - parentRect.right;
            popoversContainer.style.left = (popoversContainer.offsetLeft - overflowAmountWidth) + "px";
        }
    
        // Vérification en hauteur
        if (popoverRect.bottom > window.innerHeight) {
          let overflowAmountHeight = popoverRect.bottom - window.innerHeight;
          popoversContainer.style.top = (popoversContainer.offsetTop - overflowAmountHeight - obj.offsetHeight) + "px";
      }
    
    }, 0);
    
    
    
}

document.addEventListener("click", function (event) {
    document.querySelector(".popovers").style.display = "none";
});


function addExtraClass(obj, extraClass) {
  if (!extraClass) return;
  extraClass = extraClass.split(",");
  for (var i = 0; i < extraClass.length; i++)
     obj.classList.add(extraClass[i]);
}

//specific search for select2 HTML data formating
function matchCustom(params, data) {
    if ($.trim(params.term) === '') return data;
  
    var $option = $(data.element);
    var textForSearch = $option.data('textForSearch'); 
    if (typeof textForSearch === 'undefined') return null;
    if (textForSearch.toLowerCase().indexOf(params.term.toLowerCase()) > -1) return data;
    return null;
  }