//shortcuts
function L(key) {
    return localizer.getMessage(key);
}

// Localizer class
class Localizer {
    constructor(language) {
      this.language = language;
      this.messages = {};
      this.loadMessages();
    }
  
    loadMessages() {
      $.ajax({
        url: `localization/${this.language}.json`,
        dataType: 'json',
        async: false,  
        success: (data) => {
          this.messages = data;
        },
        error: () => {
          console.error(`Failed to load localization file for ${this.language}`);
        }
      });
    }
  
    getMessage(key) {
      return this.messages[key] || key;
    }
  }
  
  const localizer = new Localizer('en'); 
  

// change labels in html page
function loadTranslations(language) {
$.getJSON(`${language}.json`, function(translations) {
    $('[data-localize]').each(function() {
    const key = $(this).data('localize');
    const translation = translations[key];
    if (translation) {
        if ($(this).is('input, textarea')) {
        $(this).attr('placeholder', translation);
        } else {
        $(this).text(translation);
        }
    }
    });
});
}

// change labels in html page
$(document).ready(function() {
    loadTranslations('fr'); 
  });
  
