// Load the configuration file and initialize the app
var sageActiveEnvironment;
var headerWithoutTenant;
var headerWithoutOrganization;
var headerWithOrganization;
var urlAPI;
var maxParallelismLimit;
var forceMaxParallelismLimit;
var maxAccountingEntries;


//Get url Proxy and launch authentication
$(document).ready(function() {
  waitInfo(); 
  $.getJSON('config.json', function(config) {
      urlAPI = config.proxyUrl;
      maxParallelismLimit = config.maxParallelismLimit;
      forceMaxParallelismLimit = config.forceMaxParallelismLimit;
      maxAccountingEntries = config.maxAccountingEntries;
      console.log(`INFO : urlAPI: ${urlAPI}, maxParallelismLimit: ${maxParallelismLimit}, forceMaxParallelismLimit: ${forceMaxParallelismLimit}, maxAccountingEntries: ${maxAccountingEntries}`);

      disableInterface();
      checkAccessToken().then(() => {
          if (currentAccessToken) init();
      });
  }).fail(function() {
      displayBusinessError("Error loading configuration from config.json file","",false);
      waitInfo(false);
  });
});

//when we have a token we can initialize the app
function init() {
  headerWithoutTenant = {
    "Content-Type": "application/json",
    "Authorization": "Bearer " + currentAccessToken,
    "x-sageactive-env": sageActiveEnvironment
  };

  readUserProfile()
    .then(() => {
       return readAllOrganizationsAndInitPage(activeOrganizationId);
    })
}


function initPage(){
   if (!checkUserAppAccess()) return;

  Promise.all([readTariffs()]).then(() => {
     mapDocumentTypesToCountries();
    resetCustomer();
    askForImportData();
  });
}




