//Get userProfile to obtain tenant & current Organization
var activeTenantId;
var activeOrganizationId;
var activeLegislationCode;
var userProfile;
var tooLongInfo;

function readUserProfile() {

    tooLongInfo=setTimeout(function(){
      if (tooLongInfo)
        displayBusinessInfo("To reduce infrastructure costs, the public API and other resources enter sleep mode during inactivity",false);
    },4000); 

    $('#infoUserProfile').html(`
    Sage Active: ${sageActiveEnvironment}<br>
  `);

    return new Promise((resolve, reject) => {
      genericFetchPublicAPI(headerWithoutTenant,qm.queryUserProfile,null, handleResponse);
      function handleResponse(data) {
        if (data && data.data && data.data.userProfile) {
          userProfile=data.data.userProfile;

          if (localStorage.getItem("activeOrganizationId")) activeOrganizationId = localStorage.getItem("activeOrganizationId");

          resolve();
        } else {
          reject();
        }
      }
    });
  }

var organizationTenantDict = {};

  function readAllOrganizationsAndInitPage(organizationId) {
    return new Promise((resolve, reject) => { 
      genericFetchPublicAPI(headerWithoutTenant, qm.queryOrganizations, null, handleResponse);
      function handleResponse(data) {
        tooLongInfo=false;
        if (data && data.data && data.data.organizations && Array.isArray(data.data.organizations.edges)) {
          const allOrganizations = data.data.organizations.edges;     

          var selectElement = $('#organizations');
          selectElement.empty(); 
          if (allowedSageActiveEnvs.length>1)
            addNavigateOption(selectElement,"Switch to another Sage Active environment", "OTHERENV");
  
          allOrganizations.forEach(function( {node: organization}) {
            var text=organization.socialName;        
 
            var option = new Option(text, organization.id);
            if (isOrganizationNotReady(organization)) {
               $(option).attr('data-notready', true);
               $(option).attr('data-status', getOrganizationStatusKeyword(organization));
            }
            selectElement.append(option);
 
            organizationTenantDict[organization.id] = {
              tenantId: organization.tenantId,
              legislationCode: organization.legislationCode
            };
          });
  
          if (!organizationId || !allOrganizations.some(o => o.node.id === organizationId && !isOrganizationNotReady(o.node))) {
            const firstReadyOrganization = allOrganizations.find(o => !isOrganizationNotReady(o.node));
            if (firstReadyOrganization) {
                organizationId = firstReadyOrganization.node.id;
                selectElement.val(organizationId);
            } else {
                displayBusinessError("ALLNOTREADY");
                localStorage.removeItem("activeOrganizationId");
                $('#searchCustomer,#displayCustomerInput').prop('disabled',true);
                activeOrganizationId = null;
                selectElement.val("");
                return;
            }
          } else {
            selectElement.val(organizationId);
          } 
        
          selectElement.trigger('change'); // To call initPage() 
          $('#organizations').next('.select2').show();
          $('#otherenvs').next('.select2').hide();
          resolve();
        }
      }
    });
  };


  function isOrganizationNotReady(organization) {
    return organization.onboardingCompleted === false;
  }
  function getOrganizationStatusKeyword(organization) {
    if (organization.onboardingCompleted === false) {
        return "Onboarding"; 
    } else {
        return "Ready";
    }
}

 
  $(document).ready(function() {

    $('#organizations, #otherenvs').select2({
      containerCssClass: "custom-select2-org-env",
      templateResult: function (data) {
        if (data.id === 'OTHERENV' || data.id === 'LISTORG' || data.id === 'OTHER') {
          return $('<span>').text(data.text).css('font-weight', 'bold');
        }
        if (data.element && $(data.element).data('notready')) {
          var mainSpan = $('<span>').text(data.text).css('color','red'); 
          var pillSpan = $('<span class=organizationStatus>').text($(data.element).data('status'));
          
          mainSpan.append(pillSpan);
          return mainSpan;
        }
        return data.text;
      }
    });

    $('#organizations, #otherenvs').on('select2:open', function() {
      $('.select2-search__field').attr('placeholder', 'Filter here...'); 
    });


    $('#otherenvs').next('.select2').hide();

    // Prevent selecting organizations that are not ready
    $('#organizations').on('select2:selecting', function(e) {
      if ($(e.params.args.data.element).data('notready')) {
          e.preventDefault();
          displayBusinessError("NOTREADY");
      }
    });

    // Handle when the dropdown is closing to reset error messages
    $('#organizations').on('select2:closing', function(e) {
      var selectedData = $('#organizations').select2('data');
      if (selectedData.length && !$(selectedData[0].element).data('notready')) {
          hideBusinessMessages();
      }
    });


    // Current organization, call initPage() to initialize and allows the user to work.
    $('#organizations').change( function(e) {
 
      if ($(this).val()=="OTHERENV"){
        otherEnvs({ returnToOrganizations: true, forceLogout: true });
        return;
      }
      
      activeOrganizationId = $(this).val(); 
      if (!activeOrganizationId) {
        displayBusinessError("ALLNOTREADY");
        return;
      }
      activeTenantId=organizationTenantDict[activeOrganizationId].tenantId;
      activeLegislationCode=organizationTenantDict[activeOrganizationId].legislationCode;
      localStorage.setItem("activeOrganizationId", activeOrganizationId);

      headerWithoutOrganization = {
        ...headerWithoutTenant,
        "X-TenantId": activeTenantId,
      };
      headerWithOrganization = {
        ...headerWithoutOrganization,
        "X-OrganizationId": activeOrganizationId
      };

      $('#infoUserProfile').html(`
        ${userProfile.fullName}<br>
        ${userProfile.authenticationEmail}<br>
        Legislation: <span class=activeLegislation>${activeLegislationCode}</span><br>
        Sage Active: ${sageActiveEnvironment.toUpperCase()}
      `);


      checkUserAccessPolicies().then(() => {
        initPage();
      });
    });

    //Management of environments 
    $('#otherenvs').change(function() {
       var choice=$(this).val();
       if (choice==sageActiveEnvironment.toUpperCase()) return;

       if (choice=="LISTORG"){
        $('#organizations').val(activeOrganizationId).trigger("change"); 
        $('#organizations').next('.select2').show();
        $('#otherenvs').next('.select2').hide();
        return;
       }
       else if (choice=="OTHER"){
        $('#otherenvs').next('.select2').hide();
        $('#otherenv').show();
        $('#otherenv').attr("placeholder", "PRnnnn");
        $('#otherenv').focus();
        return;
       }
       ChangeEnvAndForceLogout({ env: choice, forceLogout: $('#otherenvs').data('forceLogout') });
    });

    $('#otherenv').blur(function() {
      var choice=$(this).val().toUpperCase();
      if (choice==""){
        $('#otherenvs').next('.select2').show();
        $('#otherenv').hide();
        $('#otherenvs').val(sageActiveEnvironment.toUpperCase()).trigger("change"); 
        setTimeout(function(){displayBusinessWarning("Invalid choice. Return to the list of environments");},300);
      }
      else
        ChangeEnvAndForceLogout({ env: choice, forceLogout: $('#otherenvs').data('forceLogout') });
    });
});

//Generate the list of other available Sage Active environments
function otherEnvs({ returnToOrganizations = false, forceLogout = false }){
    if (allowedSageActiveEnvs.length==1) return;
    
    var selectElement = $('#otherenvs');
    selectElement.empty(); 
    selectElement.data('forceLogout', forceLogout);

    var otherEnvs = (!returnToOrganizations)?[]:["LISTORG"];
    var envsProd = ["FR", "ES", "DE"];
    envsProd.forEach(env => {
      if (allowedSageActiveEnvs.includes(env.toLowerCase())) {
        otherEnvs.push(env);
      }
    });
    if (otherEnvs.length > 1)  otherEnvs.push("-");
    allowedSageActiveEnvs.forEach(env => {
      if (!envsProd.includes(env.toUpperCase()) && env !== "*") {
        otherEnvs.push(env.toUpperCase());
      }
    });
    if (allowedSageActiveEnvs.includes("*")) {
      otherEnvs.push("OTHER");
    }

    otherEnvs.forEach(function(env) {
      if (env=="-")
        selectElement.append( $('<optgroup label=""></optgroup>'));
      else if (env=="LISTORG")
          addNavigateOption(selectElement,"Return to the list of organizations",env);
      else if (env=="OTHER") 
          addNavigateOption(selectElement,"Standalone or other environment not present in the list",env);
      else{
        if (env!="STANDALONE"){
          var name=env;
          if (name==sageActiveEnvironment.toUpperCase()) name=name+" (current)";
          selectElement.append(new Option(name,env));
        }
      }
    });

    if (selectElement.find(`option[value='${sageActiveEnvironment.toUpperCase()}']`).length === 0) 
      selectElement.append(new Option (sageActiveEnvironment+" (current)",sageActiveEnvironment));

    selectElement.val(sageActiveEnvironment.toUpperCase());
    
    $('#organizations').next('.select2').hide();
    $('#otherenvs').next('.select2').show();
    $('#otherenvs').select2('open');
}

function addNavigateOption(selectElement,name,code){
  selectElement.append( $('<optgroup label=""></optgroup>'));
  var option=new Option(name, code);
  selectElement.append(option);
  selectElement.append( $('<optgroup label=""></optgroup>')); 
}


